//#include "stdafx.h"
#include <windows.h>
#include "Registry.h"

registryClass::registryClass()
{
	regKey=NULL;
}

registryClass::~registryClass()
{
	if(regKey)
		RegCloseKey(regKey);
}
// *****************************************************************************

BOOL registryClass::openReg(char *programName)
{
	if(RegOpenKeyEx(HKEY_LOCAL_MACHINE, programName, NULL , KEY_ALL_ACCESS , &regKey)==ERROR_SUCCESS)
		return TRUE;
	else // open failed -> key created
		return FALSE;
}
// *****************************************************************************

BOOL registryClass::openCreateReg(char *programName)
{
	if(RegOpenKeyEx(HKEY_LOCAL_MACHINE, programName, NULL , KEY_ALL_ACCESS , &regKey)==ERROR_SUCCESS)
		return TRUE;
	else // open failed -> create the key
	{
	DWORD disp;
		RegCreateKeyEx( HKEY_LOCAL_MACHINE , programName, NULL , NULL, REG_OPTION_NON_VOLATILE , KEY_ALL_ACCESS , NULL , &regKey , &disp );
		if(disp == REG_CREATED_NEW_KEY)
			return TRUE;
		else
			return FALSE;
	}
}
// *****************************************************************************

void registryClass::closeReg()
{
	RegCloseKey(regKey);
	regKey=NULL;
}
// *****************************************************************************

void registryClass::DeleteRegVal(char *programName)
{
	RegDeleteValue(regKey,programName);
}
// *****************************************************************************

void registryClass::setRegBool(char *keyStr , BOOL val)
{
	RegSetValueEx(regKey , keyStr , NULL , REG_BINARY , (BYTE *)&val , sizeof(BOOL));
}
// *****************************************************************************

void registryClass::setRegByte(char *keyStr , BYTE val)
{
DWORD t=val;
	RegSetValueEx(regKey , keyStr , NULL , REG_DWORD , (BYTE *)&t , sizeof(DWORD));
}
// *****************************************************************************

void registryClass::setRegWord(char *keyStr , WORD val)
{
DWORD t=val;
	RegSetValueEx(regKey , keyStr , NULL , REG_DWORD , (BYTE *)&t , sizeof(DWORD));
}
// *****************************************************************************

void registryClass::setRegDword(char *keyStr , DWORD val)
{
	RegSetValueEx(regKey , keyStr , NULL , REG_DWORD , (BYTE *)&val , sizeof(DWORD));
}
// *****************************************************************************

void registryClass::setRegFloat(char *keyStr , float val)
{
	RegSetValueEx(regKey , keyStr , NULL , REG_BINARY , (BYTE *)&val , sizeof(float));
}
// *****************************************************************************

void registryClass::setRegStr(char *keyStr , char *valStr)
{
	RegSetValueEx(regKey , keyStr , NULL , REG_SZ , (BYTE *)valStr , strlen(valStr)+1);
}
// *****************************************************************************

void registryClass::setRegValN(char *keyStr , BYTE *addr,  int size)
{
	RegSetValueEx(regKey , keyStr , NULL , REG_BINARY , addr , size);		
}



// *****************************************************************************
// *****************************************************************************
// *****************************************************************************



BOOL registryClass::getSetRegBool(char *keyStr, BOOL val)
{
BOOL tempVal;
DWORD len;

	if(RegQueryValueEx(regKey , keyStr , NULL , NULL, (BYTE *)&tempVal , &len )!=ERROR_SUCCESS)
	{
		RegSetValueEx(regKey , keyStr , NULL , REG_BINARY , (BYTE *)&val , sizeof(BOOL));
		return val;
	}
	return tempVal;
}
// *****************************************************************************

BYTE registryClass::getSetRegByte(char *keyStr, BYTE val)
{
DWORD tempVal;
DWORD len;

	if(RegQueryValueEx(regKey , keyStr , NULL , NULL, (BYTE *)&tempVal , &len )!=ERROR_SUCCESS)
	{
		tempVal=val;
		RegSetValueEx(regKey , keyStr , NULL , REG_DWORD , (BYTE *)&tempVal , sizeof(DWORD));
		return val;
	}
	return (BYTE)tempVal;
}
// *****************************************************************************

WORD registryClass::getSetRegWord(char *keyStr, WORD val)
{
DWORD tempVal;
DWORD len;

	if(RegQueryValueEx(regKey , keyStr , NULL , NULL, (BYTE *)&tempVal , &len )!=ERROR_SUCCESS)
	{
		tempVal=val;
		RegSetValueEx(regKey , keyStr , NULL , REG_DWORD , (BYTE *)&tempVal , sizeof(DWORD));
		return val;
	}
	return (WORD)tempVal;
}
// *****************************************************************************

DWORD registryClass::getSetRegDword(char *keyStr, DWORD val)
{
DWORD tempVal;
DWORD len=sizeof(DWORD);

	if(RegQueryValueEx(regKey , keyStr , NULL , NULL, (BYTE *)&tempVal , &len )!=ERROR_SUCCESS)
	{
		RegSetValueEx(regKey , keyStr , NULL , REG_DWORD , (BYTE *)&val , sizeof(DWORD));
		return val;
	}
	return (DWORD)tempVal;
}
// *****************************************************************************

float registryClass::getSetRegFloat(char *keyStr, float val)
{
float tempVal;
DWORD len=sizeof(float);

	if(RegQueryValueEx(regKey , keyStr , NULL , NULL, (BYTE *)&tempVal , &len )!=ERROR_SUCCESS)
	{
		RegSetValueEx(regKey , keyStr , NULL , REG_BINARY , (BYTE *)&val , sizeof(float));
		return val;
	}
	return tempVal;
}
// *****************************************************************************

int registryClass::getSetRegStr(char *keyStr, char *tempString, char *dest, int maxLen)
{
DWORD tempLen=maxLen;
	
	if(RegQueryValueEx(regKey , keyStr , NULL , NULL, (BYTE *) dest , &tempLen )!=ERROR_SUCCESS)
	{
		if(!tempString)
		{
			*dest=0;
			return 0;
		}
		strcpy(dest,tempString);
		tempLen=strlen(tempString)+1;
		RegSetValueEx(regKey , keyStr , NULL , REG_SZ , (BYTE *)tempString , tempLen);
	}
	return tempLen;
}
// *****************************************************************************

int registryClass::getSetRegValN(char *keyStr, BYTE *tempAddr, BYTE *addr, int size)
{
DWORD tempLen=size;

	if(RegQueryValueEx(regKey , keyStr , NULL , NULL, (BYTE *)addr , &tempLen )!=ERROR_SUCCESS)
	{
		if(!tempAddr)
		{
			*addr=0;
			return 0;
		}
		memcpy(addr,tempAddr,size);
		RegSetValueEx(regKey , keyStr , NULL , REG_BINARY , (BYTE *)addr , size);
	}
	return tempLen;
}
